import waba.ui.*;
import extra.ui.*;
import waba.fx.*;

/**
 * This program just tests the preferred size feature of controls as well as displays
 * all the available controls, including the scrolling of long lists.
 */
public class ControlTest extends ExtraMainWindow
{ 
  MenuBar mb;
	Edit edit;
    
  public ControlTest()
  {
    // create palm title bar
    super("ControlTest");

    // add long list to the top right
    String[] els={"One","Two","Three","Four","Five","Six","Seven","Eight",
      "Nine","Ten","Eleven","Twelve","Thirteen","Fourteen","Fifteen","Sixteen",
      "Seventeen","Eighteen","Nineteen","Twenty"};
    add(new List(els),RIGHT,TOP);
    
    // add menus an bars
    String[] mls={"File :)","New","Open","-","Save","Save as","Quit"};
    String[] mls2={"Edit","Copy","Paste","Cut","-","Select all"};
    String[] mls3={"Window","Long items.","-","Bla bla bla bla bla bla bla bla bla"};
    String[] mls4={"Help","Unfortunately...","Shortcuts ...","Are ...","Not ...","Available ..."};
    mb = new MenuBar();
    mb.add(new Menu(mls));
    mb.add(new Menu(mls2));
    mb.add(new Menu(mls3));
    mb.add(new Menu(mls4));
		setMenuBar(mb);

    // add a row of controls under the titlebar
    add(new Label("Label"),LEFT,BELOW,getTitle());
    add(new Check("Check"),RIGHTOF,SAME);
    add(new Radio("Radio"),RIGHTOF,SAME);
    add(edit=new Edit(),RIGHTOF,SAME);

   // add a pushbutton group.  Only one pushbutton in a group can be
    // selected at once.    
    Pushbutton[] pb=Pushbutton.createGroup(
      new String[]{"Black","White","Grey","Purple"},1);

    setGaps(-1,3); // set xgap overlapping so pushbuttons sit together
    add(pb[0],LEFT,BELOW);
    for(int i=1;i<pb.length;i++)
      add(pb[i],RIGHTOF,SAME);
    setGaps(3,3); // reset the xgap

    // add button and bignumber centered below it
    add(new Button("Menu"),RIGHTOF,SAME);
    add(new BigNumber(5),CENTER,BELOW);
  }
  
  public void onEvent(Event e)
  {
    if (e.type == ControlEvent.PRESSED)
    {
			// Use the Button to show it up for Java
			if (e.target instanceof Button)
				mb.show();
			else
			if (e.target instanceof Menu)
			{
			  String sel=((Menu)e.target).getSelected();
			  if (sel.equals("Quit"))
				  exit(0);
				else
  			  edit.setText(((Menu)e.target).getSelected());
			}
    }
  }
}