import waba.ui.*;
import extra.ui.*;
import extra.util.Maths;
import waba.fx.*;

/**
 * This is a bit more complicated example which is for comparing prices at a supermarket.
 * You can see if 3 for $5 is cheaper than 4 for $7.  Just put in the total price in the top
 * number, and the amount in the middle number and it gives you the unit price.  The list changes
 * the mode of changing the numbers and the button changes which dollar amount changes when you
 * change the amount.
 */
public class PriceCheck extends ExtraMainWindow
{  
  List type;
  Money mon,amnt,each;
  Button look;
  String looks[]={"Change Total Price","Change Each Price"};
  int currentLook=1;
  public PriceCheck()
  {
    super("PriceCheck",true);
    String[] els={"Direct","Up Down"};
    add(type=new List(els),RIGHT,TOP);    
    GridContainer grid=new GridContainer(4,3);
    add(mon=new Money(2,2),CENTER,BELOW,FILL,40,getTitle());
    add(amnt=new Money(2,0),CENTER,BELOW,80,40);
    add(each=new Money(2,2),CENTER,BELOW,FILL,40);
    add(look=new Button(looks[currentLook]),CENTER,BOTTOM);
  }
  
  public void onEvent(Event e)
  {
    if (e instanceof ControlEvent)
    {
      if (e.target==type)
      {
        int m=type.getSelectedIndex();
        mon.setMode(m);
        amnt.setMode(m);
        each.setMode(m);
        return;
      }
      if ((e.target==mon&&currentLook==0)||(e.target==each&&currentLook==1))
        flipFixed();
      if (e.target instanceof Money)
      {
        float am=amnt.getNumber();
        if (am!=0.0f)
          if (currentLook==0)
            mon.setNumber(each.getNumber()*am);
          else
            each.setNumber(mon.getNumber()/am);
       }
      else
      if (e.target==look)
      {
        flipFixed();
      }
    }
  }
 
  public void flipFixed()
  {
    currentLook=(currentLook==1?0:1);
    removePermanently(look);
    add(look=new Button(looks[currentLook]),CENTER,BOTTOM);
  }
}

class Money extends GridContainer
{
  BigNumber[] num;
  int whole=0;
  int decimal=0;
  int full=0;
  int minMult;
  
  public void setMode(int m)
  {
    for(int i=0;i<full;i++)
      num[i].setMode(m);
  }
  
  public Money(int whole,int decimal)
  {
    super(whole+(decimal>0?decimal+2:0),1);
    setGaps(5,5);
    this.whole=whole;
    this.decimal=decimal;
    full=whole+decimal;
    minMult=1;
    for(int i=whole;i<full;i++)
      minMult*=10;
    num=new BigNumber[full];
    if (decimal>0)
      add(new BigNumber(BigNumber.DOLLAR,BigNumber.NONE));
    for(int i=0;i<full;i++)
    {
      if (i==whole&&decimal>0)
        add(new BigNumber(BigNumber.POINT,BigNumber.NONE));
      add(num[i]=new BigNumber(0,BigNumber.DIRECT));
    }
  }
  
  public void onEvent(Event e)
  {
    if (e instanceof ControlEvent)
      e.target=this;
  }
  
  public void setNumber(float fl)
  {
    int mnum=(int)(fl*minMult+0.5f);
    for(int i=full-1;i>=0;i--)
    {
      num[i].setNumber(mnum%10);
      mnum/=10;
    }        
  }
  
  public float getNumber()
  {
    int mnum=0;
    for(int i=0;i<full;i++)
    {
      mnum=(mnum*10)+num[i].getNumber();
    }
    return mnum/(float)minMult;
  }
}