import waba.ui.*;
import extra.ui.*;
import waba.fx.*;


public class RelativeTest extends ExtraMainWindow
{

  public RelativeTest()
  {
    super("RelativeTest");

    // add a button to the left of the screen, below the title.  Actually
    // the getTitle() isn't actually necessary as the title was the last
    // Control added but it is included for clarity
    add(new Button("One"),LEFT,BELOW,getTitle());

    // add a new button next to the last one, filling the rest of the
    // remaining width
    Button two;
    add(two=new Button("Two"),RIGHTOF,SAME,REST,AUTO);

    // add a new button below that one, aligned to the left
    add(new Button("Three"),SAME_LEFT,BELOW);

    // add another button below the second one, this time aligned to the
    // right note the specification of the relative Control rather than the
    // default last Control added
    add(new Button("Four"),SAME_RIGHT,BELOW,two);

    // add this one below the last and attempt to align it to the left but
    // because it is much longer and the last one, it is pushed back in to
    // stay in the container
    add(new Button("Five Hundred And Six"),SAME_LEFT,BELOW);

    // create a new button and set it's size to be 30x30 then add it below
    // the last one, centered.
    Button ok=new Button("OK");
    ok.setRect(0,0,30,30);
    add(ok,SAME,BELOW);

    // add another to the left of it, aligned to the bottom of the OK button
    // and with a specified width and height
    add(new Button("Cancel"),LEFTOF,SAME_BOTTOM,60,20);

    // add another below that one, centered on the screen
    add(new Button("Center"),CENTER,BELOW);

    // add a large one, using up the remaining height and the full screen
    // width
    add(new Button("Bottom"),LEFT,BELOW,FILL,REST);

    // finally add one with no relative placement at all using the waba
    // methods, just to show they work together ok.
    Button alone=new Button("Alone");
    alone.setRect(5,62,50,15);
    add(alone);
  }
}