package waba.io;

import javax.comm.*;
import java.io.*;

public class SerialPort extends Stream
{
  javax.comm.SerialPort sPort;
  InputStream is;
  OutputStream os;
  boolean isOpen=false;

  public SerialPort(int number, int baudRate)
  {
    try
    {
      CommPortIdentifier portId = CommPortIdentifier.getPortIdentifier("COM"+(number+1));
      sPort = (javax.comm.SerialPort)portId.open("Waba", 1000);
      sPort.setSerialPortParams(baudRate,8,1,0);
      is=sPort.getInputStream();
      os=sPort.getOutputStream();
      isOpen=true;
    }
    catch(Exception e)
    {
      System.out.println("Open Error: "+e);
    }
  }

  public boolean setFlowControl(boolean on)
  {
    return true;
  }

  public boolean setReadTimeout(int millis)
  {
    try
    {
      sPort.enableReceiveTimeout(millis);
      return true;
    }
    catch(UnsupportedCommOperationException e)
    {
      return false;
    }
  }

  public boolean close()
  {
    if (!isOpen)
      return false;
    sPort.close();
    return true;
  }

  public boolean isOpen()
  {
    return isOpen;
  }

  public int readCheck()
  {
    return -1;
  }

  public int readBytes(byte buf[], int start, int count)
  {
    if (!isOpen)
      return -1;
    try
    {
      return is.read(buf,start,count);
    }
    catch(Exception e)
    {
      System.out.println("Read error! "+e);
      return -1;
    }
  }

  public int writeBytes(byte buf[], int start, int count)
  {
    if (!isOpen)
      return -1;
    try
    {
      os.write(buf,start,count);
      return count;
    }
    catch(Exception e)
    {
      System.out.println("Write error! "+e);
      return -1;
    }
  }
}